<script lang="ts">
  import {
    dragStore,
    updateDragStore,
  } from 'stores/kanbanStore';
  import { Column } from 'generated/graphql';

  export let column: Column = null;
  export let issueCount: number = 0;
  export let name;

  let columnWidth = 0;
  let columnHeight = 0;
  let coordsX = [];
  let coordsY = [];
  let columnNode;
  let accept;
  let enable;

  $: if (enable && columnNode) {
    const { x, y } = columnNode.getBoundingClientRect();
    coordsX = [x, x + columnWidth];
    coordsY = [y, y + columnHeight];
  }

  $: enable = $dragStore.isDragging && column !== $dragStore.sourceColumn;

  $: accept = $dragStore.mouseX >= coordsX[0] && $dragStore.mouseX <= coordsX[1]
    && $dragStore.mouseY >= coordsY[0] && $dragStore.mouseY <= coordsY[1];

  $: if (enable && accept) updateDragStore({ destinationColumn: column });

  $: if (enable && !accept) updateDragStore({ destinationColumn: null });
</script>

<div class="w-full h-full pb-16">
  <div class="flex justify-between items-center">
    <h2 class="dark:text-white text-xl font-semibold mb-2">{name}</h2>
    <span class="text-gray-400 dark:text-gray-500 text-xl font-semibold mb-2 mr-1">{issueCount}</span>
  </div>
  <div
    bind:clientHeight={columnHeight}
    bind:clientWidth={columnWidth}
    bind:this={columnNode}
    style="{$dragStore.isDragging ? `height: ${columnHeight + 2}px;` : ''}"
    class="relative p-2 w-full h-full rounded-lg shadow-slate-300 shadow-inner bg-white dark:bg-gray-800
      border dark:shadow-none dark:border-gray-700
      {enable
        ? 'outline-2 outline-dashed shadow-none'
        : ''}
      {enable && !accept
        ? 'outline-blue-500 bg-blue-50 dark:outline-blue-400 dark:bg-blue-900'
        : ''}
      {enable && accept
        ? 'bg-green-100 outline-green-500 dark:bg-green-900 dark:outline-green-400'
        : ''}"
  >
    <div class="hidden pointer-events-none bg-black bg-opacity-50 absolute p-1 left-0.5 bottom-0.5 z-20 translate-y-full">
      <p class="text-white text-lg">{columnHeight}</p>
      <p class="text-white text-lg">{$dragStore.destinationColumn}</p>
      <p class="text-white text-lg">x: {coordsX[0]} - {coordsX[1]}</p>
      <p class="text-white text-lg">y: {coordsY[0]} - {coordsY[1]}</p>
      <p class="text-white text-lg">mouse x: {$dragStore.mouseX}</p>
      <p class="text-white text-lg">mouse y: {$dragStore.mouseY}</p>
      <p class="text-white text-lg">$dragStore.isDragging: {$dragStore.isDragging}</p>
      <p class="text-white text-lg">$dragStore.sourceColumn: {$dragStore.sourceColumn}</p>
    </div>
    {#if !enable}
      <slot>
        <p class="dark:text-white">Nothing here yet</p>
      </slot>
    {/if}
  </div>
</div>
